#!/usr/local/bin/perl
# CMONOS.JP ñ󥹥ȡ顼 ver1.0.1
#use KCatch qw( mode=html );

use Fcntl qw(:DEFAULT :flock);
use File::Path;
use Config;
use FileHandle;
STDOUT->autoflush(1);
use strict;

my $this = {};
bless $this;

my $temp_dir = './CMONOS_JP_INSTALLER_TEMP';
my $status_file = $temp_dir . '/status';
my $status = $this->read_file($status_file) || 0;
my $perl_path = $^X;
my @error_msg = ();
my %in;
if ($ENV{'QUERY_STRING'}) {
	while ($ENV{'QUERY_STRING'} =~ /\G([^=\&]*)=([^\&]*)\&?/sgo) {
		my($k,$v) = ($1,$2);
		$k =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
		$v =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
		$in{$k} = $v;
	}
}
my $action = $in{'action'} || (($status) ? 'install' : '');
my $cmonos_dir = $this->get_cmonos_dir($temp_dir);
if ($status < 3 && $cmonos_dir) {
	$action = 'install';
	$status = 4;
}
if ($status == 5 && $action eq 'replace') {
	my $is_valid = 1;
	my $cgidatapath = ($in{'cgidatapath'}) ? $in{'cgidatapath'} : $in{'cgidata'};
	$cgidatapath .= '/' if $cgidatapath !~ m!/$!;
	my $cgidata_dir = $cgidatapath;
	$cgidata_dir =~ s!^\.\./\.\./!!;
	$cgidata_dir = './' if $cgidata_dir eq '';
	my @htdocs_files = $this->get_file_list($cmonos_dir . '/home/htdocs');
	my @cgidata_files = $this->get_file_list($cmonos_dir . '/home/cgi-data');
	if (defined $cgidatapath) {
		if ($cgidatapath !~ /^\.\.\/\.\.\// || $cgidatapath =~ /[^\w\-\/\.]/) {
			push(@error_msg,'cgi-dataץեΰ֤ǧƤCGIߤХѥϤƤ');
			$is_valid = 0;
		} elsif (!-d $cgidata_dir) {
			push(@error_msg,'cgi-dataץեΰ֤ǧƤꤵ줿ǥ쥯ȥ¸ߤޤ');
			$is_valid = 0;
		} else {
			if (-d $cgidata_dir . 'cgi-data') {
				my @conflicts = grep(-e $cgidata_dir . 'cgi-data/' . $_,'.htaccess',@cgidata_files);
				if (@conflicts) {
					push(@error_msg,'cgi-dataץեǧƤ󥹥ȡ뤵եޤϥեƱ̾Υեޤϥե¸ߤޤ(' . join(',',@conflicts) . ')');
					$is_valid = 0;
				}
			}
		}
	}
	if (defined $in{'sendmail'}) {
		if ($in{'sendmail'} =~ /[^\w\-\/\.\:]/) {
			push(@error_msg,'sendmail ѥǧƤȾѱѿϤƤ');
			$is_valid = 0;
		} elsif (!-e $in{'sendmail'}) {
			push(@error_msg,'sendmail ѥǧƤꤵ줿ѥǤ sendmail ˥ǤޤǤ');
			$is_valid = 0;
		}
	}
	if (defined $in{'dbm'}) {
		if ($in{'dbm'} !~ /^\w+_File$/) {
			push(@error_msg,'DBM μǧƤϥ顼Ǥ');
			$is_valid = 0;
		} elsif (!eval 'use ' . $in{'dbm'} . ';1;') {
			push(@error_msg,'DBM μǧƤꤵ줿 DBM ϻѤǤޤ');
			$is_valid = 0;
		}
	}
	if (defined $in{'filemode'} && $in{'filemode'} ne '' && $in{'filemode'} !~ /^06[0-6][0-6]$/) {
		push(@error_msg,'եΥѡߥåǧƤ');
		$is_valid = 0;
	}
	if (defined $in{'dirmode'} && $in{'dirmode'} ne '' && $in{'dirmode'} !~ /^07[0-7][0-7]$/) {
		push(@error_msg,'ǥ쥯ȥΥѡߥåǧƤ');
		$is_valid = 0;
	}
	if (defined $in{'cgimode'} && $in{'cgimode'} ne '' && $in{'cgimode'} !~ /^07[0-7][0-7]$/) {
		push(@error_msg,'CGI եΥѡߥåǧƤ');
		$is_valid = 0;
	}
	my @conflicts = grep(-e './' . $_,'.htaccess',@htdocs_files);
	if (@conflicts) {
		push(@error_msg,'󥹥ȡ賬ؤǧƤ󥹥ȡ뤵եޤϥեƱ̾Υեޤϥե¸ߤޤ(' . join(',',@conflicts) . ')');
		$is_valid = 0;
	}
	if ($is_valid) {
		unless (-d $cgidata_dir . 'cgi-data' || mkdir $cgidata_dir . 'cgi-data') {
			push(@error_msg,'cgi-dataץեΰ֤ǧƤꤵ줿ǥ쥯ȥˤϡcgi-dataץեǤޤǤ');
			$is_valid = 0;
		}
	}
	if ($is_valid) {
		foreach my $file (@cgidata_files) {
			rename($cmonos_dir . '/home/cgi-data/' . $file,$cgidata_dir . 'cgi-data/' . (($file eq '_htaccess') ? '.htaccess' : $file));
		}
		foreach my $file (@htdocs_files) {
			rename($cmonos_dir . '/home/htdocs/' . $file,'./' . (($file eq '_htaccess') ? '.htaccess' : $file));
		}
		my $data = $this->read_file($cgidata_dir . 'cgi-data/lib/env.pl');
		$data =~ s/^[\x20\x09]*\$sendmail[\x20\x09]*=[^;]*;/\$sendmail = '$in{'sendmail'}';/gm if defined $in{'sendmail'} && $in{'sendmail'} ne '';
		if (defined $in{'dbm'} && $in{'dbm'} ne '') {
			$data =~ s/^[\x20\x09]*\$dbm_file[\x20\x09]*=[^;]*;/\$dbm_file = '$in{'dbm'}';/gm;
			my $max = ($in{'dbm'} eq 'DB_File' || $in{'dbm'} eq 'GDBM_File') ? 128000 : ($in{'dbm'} eq 'SDBM_File' || $in{'dbm'} eq 'ODBM_File') ? 900 : 4000;
			$data =~ s/^[\x20\x09]*\$db_maxlength[\x20\x09]*=[^;]*;/\$db_maxlength = $max;/gm;
		}
		if (defined $in{'filemode'} && $in{'filemode'} ne '') {
			$data =~ s/^[\x20\x09]*\$dbm_mode[\x20\x09]*=[^;]*;/\$dbm_mode = $in{'filemode'};/gm;
			$data =~ s/^[\x20\x09]*\$file_mode[\x20\x09]*=[^;]*;/\$file_mode = $in{'filemode'};/gm;
		}
		$data =~ s/^[\x20\x09]*\$dir_mode[\x20\x09]*=[^;]*;/\$dir_mode = $in{'dirmode'};/gm if defined $in{'dirmode'} && $in{'dirmode'} ne '';
		$data =~ s/^[\x20\x09]*\$cgi_file_mode[\x20\x09]*=[^;]*;/\$cgi_file_mode = $in{'cgimode'};/gm if defined $in{'cgimode'} && $in{'cgimode'} ne '';
		$data =~ s!\.\./\.\./\.\./cgi-data!${cgidatapath}cgi-data!sg if $cgidatapath && $cgidatapath ne '../../../';
		$this->write_file($cgidata_dir . 'cgi-data/lib/env.pl',$data);
		$data = $this->read_file('./m.cgi');
		$data =~ s/\A#!\S+/#!$perl_path/m if $perl_path;
		$data =~ s!\.\./cgi-data!${cgidata_dir}cgi-data!sg if $cgidatapath && $cgidatapath ne '../../../';
		$this->write_file('./m.cgi',$data);
		foreach my $pl ($this->get_cgi_list) {
			my $changed = 0;
			$data = $this->read_file($pl);
			$changed = 1 if $perl_path && $pl =~ /\.cgi$/ && $data =~ s/\A#!\S+/#!$perl_path/m;
			if ($cgidatapath && $cgidatapath ne '../../../') {
				$changed = 1 if $data =~ s!\.\./\.\./\.\./cgi-data!${cgidatapath}cgi-data!sg;
				$changed = 1 if $data =~ s!^[\x20\x09]*\$cgi_data_name[\x20\x09]*=[^\x0A\x0D]*;!\$cgi_data_name = '${cgidatapath}cgi-data';!gm;
				$changed = 1 if $data =~ s!^[\x20\x09]*\$shared_cgi_data_name[\x20\x09]*=[^\x0A\x0D]*;!\$shared_cgi_data_name = '${cgidatapath}cgi-data';!gm;
			}
			$this->write_file($pl,$data) if $changed;
		}
		if (eval 'use Jcode;1;&Jcode::FB_XMLCREF;') {
			unlink $cgidata_dir . 'cgi-data/lib/Jcode.pm';
			rmtree $cgidata_dir . 'cgi-data/lib/Jcode';
		}
		chmod(eval($in{'cgimode'} || 0705),'./cgi/setup/start.cgi');
		my $setup = $ENV{'SCRIPT_NAME'};
		$setup =~ s![^/]+$!cgi/setup/start.cgi!;
		rmtree $temp_dir;
		print "Content-Type: text/html\n\n";
		print '<html><head><meta http-equiv="Refresh" content="0; URL=' . $setup . '" /></head>';
		print '<body></body><a href="' . $setup . '">next&raquo;</a></html>';
		exit;
	} else {
		$action = 'install';
	}
}

print <<HTML;
Content-type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=EUC-JP" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<title lang="ja">CMONOS.JP ñ󥹥ȡ顼</title>
<style type="text/css">
<!--
html,body{ height: 100%; margin: 0; padding: 0; }
body, table {
  font: 14px 'Lucida Grande','Hiragino Kaku Gothic Pro','ҥ饮γѥ Pro W3','HiraKakuProN-W3',Verdana,'ᥤꥪ','Meiryo','ͣ Хå','MS PGothic',Osaka,arial,helvetica,sans-serif;
}
body {
  background-color: #FFF;
}
div#content {
  padding: 3em 10%;
}
ol.footer {
  list-style-type: none;
  font-size: 0.8em;
}
dl {
  border-top: solid 1px #CCC;
  border-left: solid 1px #CCC;
  border-right: solid 1px #CCC;
  text-align: left;
}
dt, dd {
  margin: 0;
  padding: 0.7em 1em;
  border-bottom: solid 1px #CCC;
}
dt {
  background-color: #F3F3F3;
}
table#license-table {
  margin: 1em 0;
  border-collapse: collapse;
  empty-cells: show;
  border: 1px solid #CCC;
  font-size: 0.9em
}
table#license-table td, table#license-table th {
  margin: 0;
  padding: 0.7em 1em;
  border: 1px solid #CCC;
  background-color: #F3F3F3;
}
table#license-table th {
  background-color: #EEE;
  white-space: nowrap;
}
table#license-table td.title, table#license-table td.support {
  text-align: center;
  white-space: nowrap;
}
table#license-table td.price {
  text-align: right;
  white-space: nowrap;
}
table#license-table tr:hover td {
  background-color: #FFF;
}
div#progress-bar-box-bg {
  width: 100%;
  height: 100%;
  position: fixed !important;
  position: absolute;
  top: 0;
  left: 0;
  background-color: #000;
  z-index: 100;
  opacity: 0.7;
  -moz-opacity: 0.7;
  -webkit-opacity: 0.7;
  -o-opacity: 0.7;
  -ms-filter:"alpha(opacity=70)";
  filter:alpha(opacity=70);
}
div#progress-bar-box {
  width: 100%;
  height: 100%;
  position: fixed !important;
  position: absolute;
  top: 0;
  left: 0;
  z-index: 101;
  color: #FFF;
  text-align: center;
}
div#progress-bar-box a {
  color: #FFF;
  text-decoration: none;
}
div#progress-bar-dialog {
  text-align: left;
  padding-top: 200px;
  width: 482px;
  margin: 0 auto;
}
div#progress-bar-bg {
  text-align: left;
  width: 480px;
  height: 24px;
  margin: 0 auto;
  background-color: rgba(0, 0, 0, 0.5) !important;
  background-color: transparent;
  border: 1px #CCC solid;
}
div#progress-bar {
  width: 1px;
  height: 24px;
  margin: 0;
  background-color: #69F;
  border: none;
}
table {
  border-collapse: collapse;
  empty-cells: show;
  border: 1px solid #CCC;
  font-size: 0.9em
}
td, th {
  margin: 0;
  padding: 0.7em 1em;
  border: 1px solid #CCC;
  background-color: #F3F3F3;
}
th {
  background-color: #EEE;
  text-align: right;
  white-space: nowrap;
}
tr:hover td, tr:hover th {
  background-color: #FFF;
}
form {
  margin: 3em auto;
  text-align: center;
}
input.submit {
  margin: 1em auto;
  font-size: 1.5em;
}
.warning {
  color: red;
}
-->
</style>
<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
var progressbar = {
	update : function (ratio) {
		if (typeof document.body.style.maxHeight == "undefined") {
			document.getElementById('progress-bar-box-bg').style.height = (document.body.scrollTop + document.body.clientHeight) + 'px';
			document.getElementById('progress-bar-box-bg').style.width = (document.body.scrollLeft + document.body.clientWidth) + 'px';
		}
		if (ratio >= 1) {
			document.getElementById('progress-bar').style.width = '480px';
			document.getElementById('progress-bar-dialog').innerHTML += '[λ]';
			document.getElementById('progress-bar-box-bg').style.display = 'none';
			document.getElementById('progress-bar-box').style.display = 'none';
			if (this.bar_timer != null) clearInterval(this.bar_timer);
		} else {
			this.ratio = ratio;
			var self = this;
			if (this.bar_timer == null) this.bar_timer = setInterval(function () {
				self.ratio += 0.005;
				if (self.ratio > 0.99) self.ratio = 0.99; 
				var w = Math.floor(self.ratio * 480);
				document.getElementById('progress-bar').style.width = ((w > 0) ? w : 1) + 'px';
			},500);
		}
	}
};
// ]]> -->
</script>
</head>
<body>
HTML

if (!$action) {
	$this->print_license;
	print '</body></html>';
	exit;
} elsif (!-d $temp_dir && !mkdir($temp_dir)) {
	my $dl_url = $this->download_path(($perl_path =~ /local/) ? 1 : 0);
print <<CONTENT;
<div id="content">
<p>ѥǥ쥯ȥǤޤǤȤΥФǤϡ<a href="http://cmonos.jp/manual/setup_assistant/operation/easyinstall.html" target="_blank">CMONOS.JP ñ󥹥ȡ顼</a>פˤ륤󥹥ȡ뤬Ǥޤ</p>
<p><a href="$dl_url">CMONOS.JP ե륻å</a>פɤ<a href="http://cmonos.jp/manual/setup_assistant/operation/install.html" target="_blank">󥹥ȡޥ˥奢</a>ˤäƥ󥹥ȡ뤷Ƥ</p>
</div>
</body>
</html>
CONTENT
	exit;
} elsif ($status >= 4) {
	$this->print_extract_error if !$cmonos_dir;
	$this->write_file($status_file,5);
	print '<div id="content"><h1>ƥ</h1>';
	print '<p class="warning">ϥ󥹥ȡѹǤޤ</p>';
	if (@error_msg) {
		print '<ul>';
		foreach my $msg (@error_msg) {
			print '<li>' . $msg . '</li>';
		}
		print '</ul>';
	}
	print '<form action="./installer.cgi" method="GET"><input type="hidden" name="action" value="replace" /><dl>';
	print '<dt><label for="cgidata">CMONOS.JP⥸塼Τۤǡ١ʤɤǼcgi-dataץեΰ(./cgi/setup/start.cgiפߤХѥ)</label></dt>';
	print '<dd>';
	my $here = $this->get_cwd;
	my $dir = ($here =~ m!/([^/]+)$!) ? $1 : '?';
	if ($dir eq 'web') {
		print '<p class="warning">֥ݥåסס֥åѡפʤɡǥ쥯ȥγؤ˥ǤʤФǤϡǥ쥯ȥγؤФ˻ꤷʤǤǥ쥯ȥγؤꤹ FTP ǡcgi-dataץե˥Ǥʤʤ뤿ᡢƥʥ󥹤ˤʤޤ</p>';
		$in{'cgidata'} = '../../' if !$in{'cgidata'};
	} elsif (!$in{'cgidata'}) {
		$in{'cgidata'} = '../../../';
	}
	print '<select name="cgidata" id="cgidata">';
	my $menu = '<option value="../../"' . (($in{'cgidata'} && $in{'cgidata'} eq '../../') ? ' selected="selected"' : '') . '>(' . $dir . ') ../../</option>';
	my $rel = '../../';
	while ($here =~ s!/[^/]+$!!) {
		my $uid = (stat($here))[4];
		last if $uid ne $> && $uid ne $<;
		$rel .= '../';
		$dir = ($here =~ m!/([^/]+)$!) ? $1 : '?';
		$menu = '<option value="' . $rel . '"' . (($in{'cgidata'} && $in{'cgidata'} eq $rel) ? ' selected="selected"' : '') . '>(' . $dir . ') ' . $rel . '</option>' . $menu;
	}
	print $menu;
	print '</select></dd>';
	print '<dd>¾:<input type="text" size="80" name="cgidatapath" value="' . $this->escape($in{'cgidatapath'}) . '" />/cgi-data</dd>';
	print '<dt><label for="sendmail">sendmail ΰ</label></dt>';
	if (!$in{'sendmail'}) {
		$in{'sendmail'} = '/usr/sbin/sendmail';
		if (-e '/usr/sbin/sendmail') {
			$in{'sendmail'} = '/usr/sbin/sendmail';
		} elsif (-e '/usr/lib/sendmail') {
			$in{'sendmail'} = '/usr/lib/sendmail';
		}
	}
	print '<dd><input type="text" size="80" name="sendmail" id="sendmail" value="' . $this->escape($in{'sendmail'}) . '" /></dd>';
	print '<dt><label for="dbm">DBM μ</label></dt>';
	print '<dd><select name="dbm" id="dbm">';
	my $ex = $Config{'extensions'};
	print '<option value="DB_File"' . (($in{'dbm'} && $in{'dbm'} eq 'DB_File') ? ' selected="selected"' : '') . '>DB_File(侩)</option>' if eval 'use DB_File;1;';
	print '<option value="GDBM_File"' . (($in{'dbm'} && $in{'dbm'} eq 'GDBM_File') ? ' selected="selected"' : '') . '>GDBM</option>' if $ex =~ /GDBM_File/;
	print '<option value="NDBM_File"' . (($in{'dbm'} && $in{'dbm'} eq 'NDBM_File') ? ' selected="selected"' : '') . '>NDBM</option>' if $ex =~ /NDBM_File/;
	print '<option value="SDBM_File"' . (($in{'dbm'} && $in{'dbm'} eq 'SDBM_File') ? ' selected="selected"' : '') . '>SDBM(侩)</option>' if $ex =~ /SDBM_File/;
	print '<option value="ODBM_File"' . (($in{'dbm'} && $in{'dbm'} eq 'ODBM_File') ? ' selected="selected"' : '') . '>ODBM(侩)</option>' if $ex =~ /ODBM_File/;
	print '</select></dd>';
	print '<dt><label for="filemode">եΥѡߥå</label></dt>';
	$in{'filemode'} = '0604' if !$in{'filemode'};
	print '<dd><input type="text" size="5" name="filemode" id="filemode" value="' . $this->escape($in{'filemode'}) . '" /></dd>';
	print '<dt><label for="dirmode">ǥ쥯ȥΥѡߥå</label></dt>';
	$in{'dirmode'} = '0705' if !$in{'dirmode'};
	print '<dd><input type="text" size="5" name="dirmode" id="dirmode" value="' . $this->escape($in{'dirmode'}) . '" /></dd>';
	print '<dt><label for="cgimode">CGI եΥѡߥå</label></dt>';
	$in{'cgimode'} = '0705' if !$in{'cgimode'};
	print '<dd><input type="text" size="5" name="cgimode" id="cgimode" value="' . $this->escape($in{'cgimode'}) . '" /></dd>';
	print '</dl><input type="submit" class="submit" value="嵭˴Ť CMONOS.JP 󥹥ȡ顼ư" /></form>';
	print '</div></body></html>';
} else {
	my $ratio = 0;
	my $interval = 180;
	if ($status == 0) {
		$this->write_file($status_file,1);
	} elsif ($status == 1) {
		my $total = $this->read_file($temp_dir . '/CMONOS_JP.tgz.len');
		$ratio = int((-s $temp_dir . '/CMONOS_JP.tgz') / $total * 1000) / 1000 if $total && -f $temp_dir . '/CMONOS_JP.tgz';
		$interval = 10;
	} elsif ($status == 2) {
		$this->print_extract_error(1) if !-f $temp_dir . '/CMONOS_JP.tgz';
		$this->print_extract_error unless eval 'use Archive::Tar;Archive::Tar->has_zlib_support;';
		$this->write_file($status_file,3);
	} elsif ($status == 3) {
		$interval = 10;
	}
	print '<div id="progress-bar-box-bg"></div>';
	print '<div id="progress-bar-box"><div id="progress-bar-dialog">';
	if ($status < 2) {
		print 'CMONOS.JP ɤ߹Ǥޤ...';
	} else {
		print 'CMONOS.JP षƤޤ...';
	}
	print '</div><div id="progress-bar-bg"><div id="progress-bar"></div></div></div>';
	print '</body></html>';
	$this->set_refresh_timer($interval);
	$this->bar_update($ratio);
	if ($status == 0) {
		$this->get($this->download_path,$temp_dir . '/CMONOS_JP.tgz');
		$this->write_file($status_file,2);
		$this->bar_update(1);
		$this->refresh;
	} elsif ($status == 2) {
		my $tar = Archive::Tar->new();
		$tar->setcwd($temp_dir);
		$tar->read($temp_dir . '/CMONOS_JP.tgz',1);
		$tar->extract();
		$this->write_file($status_file,4);
		$this->bar_update(1);
		$this->refresh;
	}
}

sub download_path ($;$) {
my($this,$local) = @_;
return(($] >= 5.008001) ? 'http://cmonos.jp/download/CMONOS_JP_2x' : 'http://cmonos.jp/download/CMONOS_JP_1x') . (($local) ? '/CMONOS_JP_local.tgz' : '/CMONOS_JP.tgz');
}

sub print_extract_error ($;$) {
my($this,$dl) = @_;
my $title = ($dl) ? '' : '';
my $dl_url = $this->download_path;
print <<CONTENT;
<div id="content">
<p>CMONOS.JP ${title}ǤޤǤ<a href="$dl_url">CMONOS.JP ե</a>פɤषƤǤեCMONOS_JP_<em>YYYYMMDD</em>(YYYYMMDDϥ꡼ɽ)פ򡢤Υ󥹥ȡƱؤˤCMONOS_JP_INSTALLER_TEMPץե˥åץɤƤ</p>
<form action="./installer.cgi" method="GET">
<input type="hidden" name="action" value="install" />
<input type="submit" value="åץɤλΤǥ󥹥ȡƳ" />
</form>
</div>
</body>
</html>
CONTENT
exit;
}

sub get_cmonos_dir ($$) {
my($this,$temp_dir) = @_;
local(*DIR);
if (opendir(DIR,$temp_dir)) {
	my @temp = grep($_ =~ /^CMONOS_JP_\d{8}$/ && -d $temp_dir . '/' . $_,readdir(DIR));
	closedir(DIR);
	return $temp_dir . '/' . $temp[0] if @temp;
}
return '';
}

sub get_file_list ($$) {
my($this,$dir) = @_;
local(*DIR);
if (opendir(DIR,$dir)) {
	my @files = grep($_ !~ /^\.\.?$/ && $_ ne '.DS_Store',readdir(DIR));
	closedir(DIR);
	return @files;
}
return ();
}

sub get_cgi_list ($) {
my $this = shift;
local(*DIR);
my @cgi_files = ();
if (opendir(DIR,'./cgi')) {
	my @cgidir = grep($_ !~ /^\./ && -d './cgi/' . $_ && (-f './cgi/' . $_ . '/start.cgi' || -f './cgi/' . $_ . '/postman.cgi'),readdir(DIR));
	closedir(DIR);
	foreach my $cgi (@cgidir) {
		if (opendir(DIR,'./cgi/' . $cgi)) {
			push(@cgi_files,map { './cgi/' . $cgi . '/' . $_ } grep($_ =~ /^\w+\.(?:pl|cgi)$/,readdir(DIR)));
			closedir(DIR);
		}
	}
}
return @cgi_files;
}

sub bar_update ($$) {
my($this,$ratio) = @_;
print <<JAVASCRIPT;
<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
progressbar.update($ratio);
// ]]> -->
</script>
JAVASCRIPT
}

sub refresh ($) {
my $this = shift;
print <<JAVASCRIPT;
<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
window.location.reload();
// ]]> -->
</script>
JAVASCRIPT
}

sub set_refresh_timer ($$) {
my($this,$interval) = @_;
$interval *= 1000;
print <<JAVASCRIPT;
<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
setTimeout(function () { window.location.reload(); },$interval);
// ]]> -->
</script>
JAVASCRIPT
}

sub get_cwd ($) {
my $this = shift;
my $cwd;
if ($ENV{'SCRIPT_FILENAME'}) {
	$cwd = $ENV{'SCRIPT_FILENAME'};
	$cwd =~ s!/[^/]*$!!;
} else {
	chdir;
	use Cwd;
	$cwd = cwd() || getcwd;
}
return $cwd;
}

sub escape ($$) {
my($this,$str) = @_;
return '' if !defined $str;
$str =~ s/&/&amp;/gs;
$str =~ s/"/&quot;/g;
$str =~ s/</&lt;/g;
$str =~ s/>/&gt;/g;
return $str;
}

sub write_file ($$$) {
my($this,$path,$data) = @_;
local(*FH);
if (open(FH, ">>$path")) {
	binmode FH;
	flock(FH, LOCK_EX);
	truncate(FH, 0);
	seek(FH, 0, 0);
	print FH $data;
	close(FH);
	return 1;
} else {
	return 0;
}
}

sub read_file ($$) {
my($this,$path) = @_;
my $data = '';
local(*FH);
if (open(FH, $path)) {
	binmode FH;
	flock(FH, LOCK_SH);
	$data = join('',<FH>);
	close(FH);
}
return $data;
}

sub get ($$$) {
my($this,$url,$content_file) = @_;
if (!defined $this->{'ua'}) {
	if (eval{require LWP::UserAgent}) {
		$this->{'ua'} = LWP::UserAgent->new;
		$this->{'ua'}->agent('CMONOS_JP_INSTALLER');
		$this->{'ua'}->timeout(10);
	} else {
		$this->{'ua'} = '';
	}
}
if (ref $this->{'ua'}) {
	my $request = HTTP::Request->new('GET' => $url);
	my $res = $this->{'ua'}->request($request,$content_file);
	$this->write_file($content_file . '.len',$res->header('Content-Length')) if $content_file;
	return ($content_file) ? (-f $content_file) ? 1 : 0 : $res->content;
} else {
	my($host,$path) = ($url =~ m!^https?://([^/]+)(/?.*)$!is) ? ($1,$2) : ('','');
	my $header = {};
	$header->{'User-Agent'} = 'CMONOS_JP_INSTALLER';
	$header->{'Accept'} = '*/*';
	$header->{'Host'} = $host;
	local(*HTTPCLIENT);
	use Socket;
	my $port = getservbyname('http', 'tcp');
	my $sockaddr = sockaddr_in($port,inet_aton($host));
	socket(HTTPCLIENT, PF_INET, SOCK_STREAM, getprotobyname('tcp'));
	connect(HTTPCLIENT, $sockaddr);
	HTTPCLIENT->autoflush(1);
	print HTTPCLIENT "GET $path HTTP/1.0\x0D\x0A";
	while (my($k,$v) = each %$header) {
		print HTTPCLIENT $k . ': ' . $v . "\x0D\x0A";
	}
	print HTTPCLIENT "\x0D\x0A";
	my $res = <HTTPCLIENT>;
	my $content_flag = 0;
	my $content = '';
	while ($res = <HTTPCLIENT>) {
		if ($content_flag) {
			$content .= $res;
		} else {
			$res =~ s/\s+$//gs;
			if ($res ne '') {
				if ($content_file && $res =~ /Content-Length:\s*(\d+)/i) {
					$this->write_file($content_file . '.len',$1);
				}
			} elsif ($content_file) {
				last;
			} else {
				$content_flag = 1;
			}
		}
	}
	if ($content_file) {
		if (open(FILE, ">>$content_file")) {
			binmode FILE;
			flock(FILE, LOCK_EX);
			truncate(FILE, 0);
			seek(FILE, 0, 0);
			my $buf = '';
			while (read(HTTPCLIENT,$buf,8192)) {
				print FILE $buf;
			}
			close(FILE);
		}
	}
	close(HTTPCLIENT);
	return ($content_file) ? (-f $content_file) ? 1 : 0 : $content;
}
}

sub print_license ($) {
my $this = shift;
print <<LICENSE;
<div id="content">

<h1>CMONOS.JP եȥѵ</h1>
<p>ܥեȥѤܻѵʰʲܷפȤޤˤ褯ɤ߲ܥեȥϰ򥵡Ф֤硢ܥեȥ򥵡Ф֤ԵڤܥեȥѤԡʰʲ֥桼פȤޤˤܷγƾι«뤳Ȥ˹դΤȤߤʤޤܷƱդʤϡͭƤεϿǥڤӥϷ󥵡Ф顢ܥեȥڤܥեȥϢե¤ӤܥեȥѤƺեƺʤФʤޤ</p>

<h2>1</h2>
<p>ܥեȥפȤϡaܷźդ줿ե롢ǥCD-ROM¾Τ˴ޤޤƤƤΤ٤ơʡi<a href="http://openlab.jp/Jcode/index-j.html" target="_blank">Jcode.pm(JcodeեʲΥץȤޤ)</a>  Perl ץ<sup>1</sup>iinicEdit.js  nicEditorIcons.gif  JavaScript<sup>2</sup>iii"htdocs/icon" ǥ쥯ȥ <a href="http://www.feedicons.com/" target="_blank">feed-icon</a> ڤ <a href="http://kb2.adobe.com/jp/cps/353/353.html" target="_blank">PDF </a> ڤ "javascript" ǥ쥯ȥ "player.swf (GrupoSistemas Player)"<sup>3</sup> ѥåΥǥǺࡢiv"cgi-data/template/vicuna" ǥ쥯ȥʲ Vicuna CMS 󤪤 Vicuna CMS ƥץ졼Ȥ򸵤˺줿 Vicuna ߴե<sup>4</sup>ѥե¤Ӥˡv˴ϢѤΥեޤΤȤޤ¤Ӥˡb˳CMONOS ѤեȥΥåץ졼ɡѹ줿С󡢥åץǡȡɲåեڤӥԡؤΤȤޤ
</p>
<ol class="footer">
<li>1 <a href="http://openlab.jp/Jcode/index-j.html" target="_blank">Jcode.pm</a>  Dan Kogai ᤬ <a href="http://www.srekcah.org/jcode/index.html" target="_blank">jcode.pl</a> ѤȤʤѴ饤֥ǤJcode.pm  Dan Kogai ᤬ͭޤCMONOS ϡJcode.pm ѵ§ꡢۤƤޤ</li>
<li>2 CMONOS ϡ<a href="http://nicedit.com/" target="_blank">NicEdit</a> Υ饤󥹡<a href="http://sourceforge.jp/projects/opensource/wiki/licenses%2FMIT_license" target="_blank">MIT 饤</a>ˤ§ꡢܸ첽ޥۤƤޤ</li>
<li>3 CMONOS ϡ<a href="http://sourceforge.net/projects/gsplayer/">GSPlayer</a> (GrupoSistemas Player - Copyright &copy; 2009, Un Proyecto de <a href="http://www.gruposistemas.com/" target="_blank">GrupoSistemas</a>) Υ饤󥹡<a href="http://sourceforge.jp/projects/opensource/wiki/licenses%2Fnew_BSD_license" target="_blank">BSD 饤</a>ˤ§ꡢۤƤޤ</li>
<li>4 CMONOS ϡ<a href="http://vicuna.jp/" target="_blank">Vicuna CMS</a> Υ饤󥹡<a href="http://sourceforge.jp/projects/opensource/wiki/licenses%2FMIT_license" target="_blank">MIT 饤</a>ˤ§ꡢۤƤޤ</li>
</ol>

<h2>2ѷ֤</h2>
<p>ܥեȥϡ1饤󥹤Ȥˡѵ줿Ŀϻѵ줿ˡ͡ΤĿͤ˻Ѥꤵ졢1ĤΥ֥ڡǥ쥯ȥФƤΤ֤뤳ȤǤޤˡ͡Τι̤ˡ͡ΤǤ硢Ѥˡ͡Το饤󥹤ɬפǤ</p>
<dl class="ex">
<dt>ĤΥ饤󥹤ɤ</dt>
<dd><ul><li>http://..jp/ ʲ֤֥ǥ쥯ȥߤ줾δ¤ıļԤѵ줿Ŀͤľܤͧͼ㤷ϻ²㤷ϻѵ줿ˡ͡ΤĿͤ<strong></strong>硣</li></ul></dd>
<dt>ӥ饤󥹤ɬפ</dt>
<dd><ul>
<li>http://..jp/ ʲ֤֥ǥ쥯ȥߤ줾δ¤ıļԤѵ줿Ŀͤľܤͧͼ㤷ϻ²Ǥ<strong>ʤ</strong>ĿͤǤʡΡפȤߤʤޤˡ</li>
<li>http://..jp/ ʲ֤֥ǥ쥯ȥߤ줾δ¤ıļԤѵ줿ˡ͡ΤĿͤǤ<strong>ʤ</strong>硣</li>
<li>ƱФǤäƤ⡢http://..jp/~/ http://..jp/~ߡߡ/http://..jp/Τ褦˥֥ڡΰ褬̤Υǥ쥯ȥǤ硣</li></ul></dd>
</dl>
<p>ܥեȥѷ֤˱ϼ̤Ǥ</p>
<table id="license-table">
	<thead>
		<tr>
			<th class="title">ѷ</th>
			<th class="description"></th>
			<th class="support">ݡ</th>
			<th class="price">ǹ</th>
		</tr>
	</thead>
	<tbody>
		<tr id="personal">
			<td class="title">ѸĿ</td>
			<td class="description">ĿͤˤŪλѤ˸¤ޤ桼ĿͤǤäƤ⡢ƥĤȾʾ夬ܿͤθĿͻܿͤȴؤοȼ㤷ܿͤν°ˡͤζ̳ӤҲƤǤ硢뤤ϥƥĤȾʾ夬եꥨŪξʾҲ󥯽Ǥ硢Υ饤󥹤ŬѤ줺ѤȤߤʤޤޤѵĿͤľܤͧϻ²ǤϤʤͧͤͧ͡׼㤷̼ΤʤĿͤ¤ƥĤɲáԽǥѹĤ˴ؤ⡢Υ饤󥹤ŬѤޤ󡣤ȤССꤻ¿˻äƤӤ륵䥳ߥ˥ƥǡ¤СʬͿƱѤ硢ѸĿͥ饤󥹤ǤϤʤѡˡ͡Υ饤󥹤Ȥʤޤ</td>
			<td class="support">ͭ</td>
			<td class="price"><strong>&yen;0</strong></td>
		</tr>
		<tr id="business">
			<td class="title">ѡˡ͡</td>
			<td class="description">ŪλѼ㤷ϾѡѤˤ餺ˡ͡ȹ硦Ρ鵡ء¿θĿͤä륵롦٥ȼƼΤˤѤŬѤޤˡ͡Τˡ͡ΤƤ硢Ѥˡ͡Τοѡˡ͡Υ饤󥹤ɬפǤޤȼԤ֤ϻȼԤܥեȥ˴ޤޤ CGI 뤤ܥեȥˤäߤ֥ǥ쥯ȥ¾ԤͿϾͿ(ۥƥ)㤷ܥեȥѤŪȤΤǻѤϡºݤ˻ѤԤѸĿͤǤäƤ⡢ѤĿ͡ˡ͡Το㤷ֲսοΤ줫¿οѡˡ͡Υ饤󥹤ɬפǤ</td>
			<td class="support">ͭ</td>
			<td class="price"><strong>&yen;27,300</strong></td>
		</tr>
	</tbody>
</table>

<h2>3ʻѴ֡</h2>
<p>ܥեȥָ14֤Τѷ֤Ǥ̵ǻѤǤޤ14֤᤮Ѥ³硢桼ѷ֤˱򡢳CMONOS λꤹˡǻʧʤФʤޤλʧƱդǤʤϡˡͭƤεϿǥڤӥм㤷Ϸ󥵡Ф顢ܥեȥڤܥեȥϢե¤Ӥ˻ѴܥեȥѤƺեƺʤФʤޤ</p>

<h2>4֥ФϿ</h2>
<p>ܥեȥ򥤥󥿡ͥåȤ³Ǥ륵Ф֤硢ѡˡ͡Τ˳桼֤14ˡ CMONOS ˡ URL ϿʤФʤޤ󡣾ѡˡ͡Τ˳桼ϡܥեȥϿ URL ǤΤ߻Ѥ뤳ȤǤޤϿ URL ܥեȥڤܥեȥѤƺե̤ URL ܤ硢ѡˡ͡Τ˳桼ϳ CMONOS ˡǡ URL ѹˤĤϤФʤФʤޤ󡣤κݸŤ URL Υ饤󥹤ϼޤޤ󥿡ͥåȤ˸ƤʤͥåȥǻѤ硢ѡˡ͡Τ˳桼֤14ˡ CMONOS ˡǥ桼̾ڤϢܥեȥֿϿʤФʤޤϿƤʤ URL ϥФǾѡˡ͡Τ˳桼ˤ14֤ۤѤǧ줿硢 CMONOS 桼Ф6ᤷޤ</p>

<h2>5ʶػ߻Ȼѵ</h2>
<p>桼ܥեȥϿƤΤνͭͭޤܥեȥФƤθ CMONOS ͭޤ桼ϡ̵ͭˤ餺ܥեȥڤܥեȥݰƼ㤷ϲ¤Τ򡢳CMONOS εʤۡžܡͿϡ䤷ƤϤʤޤ󡣥桼ϡܥեȥܹˡΧ˰ȿ붲ΤθΤ˻ѤƤϤʤޤ󡣥桼ϡܥեȥη٤ʪŪ㤷ϴĶ㤷Ϻο»⤿餹褦ŪΤˡܥեȥѤƤϤʤޤ󡣥桼ܷ˽¤ˤơCMONOS ϥ桼ˡܥեȥHTTPСŬڤ֤CGIȤѤ뤳Ȥޤ</p>

<h2>6ʰ</h2>
<p>桼ܷ˰ȿCMONOS εʤܥեȥڤܥեȥݰƼ㤷ϲ¤ΤۡžܡͿϡ䤷硢桼ϡ CMONOS ФȤơȿܥեȥξѡˡ͡Υ饤󥹤ʰȿԤ軰Ԥۤž䤷Ȥϡžۡˤ褸Τ10ܤζۤʧΤȤޤޤѡˡ͡Τ˳桼ܷ˰ȿܥեȥָ14᤮Ƥ⡢2줿ʧȤʤܥեȥλѤ³ϡܥեȥξѡˡ͡Υ饤󥹤10ܤζۤʧȤȤޤ</p>

<h2>7Ǥ¡</h2>
<p>ἺޤतʤǤäƤ⡢CMONOS ܷ˵㤷ϴϢտŪ»ˤĤơڤǤ餤ޤ󡣽ʬʴܥեȥ̵ǻѤǤ뤳Ȥ˴դߡʤʧ줿ֵѤޤ</p>

<h2>8ʽˡ</h2>
<p>ܻѵΩϡԵڤӲ˴ؤƤܹˡΧŬѤΤȤޤ</p>

<h2>9ʴɳȽ</h2>
<p>ܷ˴ؤڤʶ˴ؤƤϡ CMONOS Ź°Ƚ쿳°ɳȽȤޤ</p>

<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
document.write('<form action="./installer.cgi" method="GET"><input type="hidden" name="action" value="install" /><input type="submit" class="submit" value="嵭ѵƱդ CMONOS.JP Υ󥹥ȡ򳫻Ϥ" /></form>');
// ]]> -->
</script>
<noscript><p class="warning">JavaScript ͭˤƺɤ߹ߤƤ</p></noscript>

</div>
LICENSE
}
